unit getstatsu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls, ComCtrls, ShellCtrls;
const max=1000000;
    wU='';
    ks='';
    wl='ţ';
type
    tword=object
        cont:string;
        count:integer;
        constructor create(s:string='');
        procedure add;
        function word:string;
    end;
  TForm1 = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    SpeedButton1: TSpeedButton;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Edit2: TEdit;
    stf: TShellTreeView;
    Panel2: TPanel;
    Button1: TButton;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    Edit4: TEdit;
    od: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure sort;
    procedure SpeedButton1Click(Sender: TObject);
    procedure stfMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
  private
    procedure _(s:string);
    { Private declarations }
  public
    { Public declarations }
  end;

var
    str:string;
    datan:integer;
    data:array[1..max] of tword;
  Form1: TForm1;

implementation

uses verinfo;

{$R *.dfm}
function convert(s:string):string;
var i,j:integer;
    res:string;
begin
    res:=s;
    for i:=1 to length(res) do 
        for j:=1 to 33 do
        if (res[i]=wU[j]) or (res[i]=wl[j]) then begin
            res[i]:=ks[j];
            break;
        end;
    convert:=res;
end;
procedure swapwords(a,b:integer);
var ts:string;
    ti:integer;
begin
    if a=b then exit;
    ts:=data[a].word;
    ti:=data[a].count;
    data[a].cont:=data[b].word;
    data[a].count:=data[b].count;
    data[b].cont:=ts;
    data[b].count:=ti;
end;
procedure tform1.sort;
var f:boolean;
    a,b,c:integer;
begin
    f:=true;
    c:=1;
    while f do begin
        f:=false;
        _(format('Pass %d of %d',[c,datan]));
        inc(c);
        for a:=1 to datan do begin
            application.ProcessMessages;
            for b:=a+1 to datan do
                if data[a].count<data[b].count then begin
                    f:=true;
                    swapwords(a,b);
                end;
        end;
    end;
end;
procedure insword(s:string;needtoconvert:boolean=true);
var i:integer;
    _s:string;
begin
    if needtoconvert then _s:=convert(s) else _s:=s;
    for i:=1 to datan do
        if _s=data[i].word then begin
            data[i].add;
            if (i>1) and (data[i-1].count<data[i].count) then swapwords(i-1,i);
            exit;
        end;
    inc(datan);
    data[datan].create(_s);

end;
function tword.word:string;
begin
    word:=cont;
end;
procedure tword.add;
begin
    inc(count);
end;
constructor tword.create(s:string='');
begin
    cont:=s;
    count:=1;
end;
procedure tform1._;
begin
    memo1.lines.add(s);
end;
procedure TForm1.FormCreate(Sender: TObject);
begin
    memo1.Lines.Clear;
    str:='';
    datan:=0;
    form1.Caption:='getstats '+ver_info+' (c) Stanislav Mikov';
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var n:tsearchrec;
    i,j,w:integer;
    p:textfile;
    n_total, n_bottom,n_text,n_ptext,n_cludges:longint;
    tn_total, tn_bottom,tn_text,tn_ptext,tn_cludges:longint;
    isnamedetected:boolean;
    ts,s,s_:string;
    sl:integer;
    t:integer;

    iscludges:boolean;
    isbottom:boolean;
    strs:tstringlist;
    max:integer;
    nc:boolean;
begin
    stf.Path:='m:\temp';
    strs:=tstringlist.Create;
    findfirst(stf.Path+'\*.msg',faAnyFile,n);
    i:=0;
    n_total:=0;
    n_cludges:=0;
    n_text:=0;
    n_bottom:=0;
    n_ptext:=0;
    datan:=0;
    w:=0;

    while findnext(n)=0 do i:=i+1;
    t:=i;
    _(inttostr(i)+' () ');
    application.ProcessMessages;
    i:=0;
    _('  '+stf.Path+'..............');

    findfirst(stf.Path+'\*.msg',faAnyFile,n);
    while findnext(n)=0 do begin
    tn_total:=0;
    tn_cludges:=0;
    tn_text:=0;
    tn_bottom:=0;
    tn_ptext:=0;
        iscludges:=true;
        isbottom:=false;
        isnamedetected:=false;
//        _(n.Name);
        assignfile(p,stf.Path+'\'+n.Name);
        reset(p);
        nc:=true;
        while not eof(p) do begin
            inc(w);
            readln(p,s);
            sl:=length(s);
            tn_total:=tn_total+sl;
            if s='' then iscludges:=false;
            if s='-- ' then isbottom:=true;
            if isbottom then tn_bottom:=tn_bottom+sl;
            if not iscludges and not isbottom then begin
                tn_text:=tn_text+sl;
                if pos('>',s)=0 then tn_ptext:=tn_ptext+sl;
            end;
//            if nc then nc:=nc and
            if (pos('charset=Windows-1251',s)<>0) then nc:=false;
            if not isnamedetected and checkbox1.Checked and
            (pos(edit1.Text,s)<>0) and (pos('From:',s)=1) then
            isnamedetected:=true;
            if (isnamedetected or not checkbox1.Checked) and not iscludges and not isbottom and (pos('>',s)=0) then begin
                strs.Clear;
                ExtractStrings([#0..#127],[],pchar(s),strs);
                for j:=0 to strs.Count-1 do begin
                    s_:=strs.Strings[j];
                    ts:=s_;
                    if (length(s_)>0) and (length(s_)<20) then insword(s_,nc);
           //         _(n.Name+' "'+ts+'" -> "'+data[datan].cont);
                end;
           end;
            if iscludges then tn_cludges:=tn_cludges+sl;
            if ((w mod 2000)=0) then _(format('%3.2f%% done, %d words found, last="%s", first="%s"',[i/t*100,datan,data[datan].cont,data[1].cont]));

        end;

        if not checkbox1.Checked or isnamedetected then begin
            n_total:=n_total+tn_total;
            n_bottom:=n_bottom+tn_bottom;
            n_text:=n_text+tn_text;
            n_ptext:=n_ptext+tn_ptext;
            n_cludges:=n_cludges+tn_cludges;
            i:=i+1;
        end;
        if ((i mod 20)=0) then _(format('%3.2f%% done, %d words found, last="%s", first="%s"',[i/t*100,datan,data[datan].cont,data[1].cont]));


        application.ProcessMessages;
        closefile(p);
 //       if i=15 then break;
    end;
    if checkbox1.Checked then _(inttostr(i)+'   '+edit1.Text+'  '+inttostr(t)+' ')
    else _(inttostr(i)+'  ');
    _(format(' : %d',[n_total]));
    _(format('       : %3.2f%%',[n_text/n_total*100]));
    _(format('       : %3.2f%%',[n_ptext/n_total*100]));
    _(format('        : %3.2f%%',[n_ptext/n_text*100]));
    _(format('      : %3.2f%%',[n_cludges/n_total*100]));
    _(format('        %3.2f%%',[n_bottom/n_total*100]));
    _(format('       %3.2f%%',[n_ptext/n_cludges*100]));
    _(format('  : %d',[n_total div i]));
    _(format('  : %d',[n_cludges div i]));
    _(format('   : %d',[n_text div i]));
    _(format('   : %d',[n_ptext div i]));
    _(format('   : %d',[(n_text-n_ptext) div i]));
    _(format('  : %d',[n_bottom div i]));
    max:=0;
    for j:=1 to datan do begin
        if data[j].count>max then max:=data[j].count;
    end;
    for j:=1 to datan do begin
        if data[j].count>round(max*0.9) then
             _(data[j].word+' ['+inttostr(data[j].count)+']');
    end;
    _('');
    _('');
    _('');
{    for j:=1 to 100 do
        _(inttostr(j)+'. '+data[j].word+' ['+inttostr(data[j].count)+']');}
    _('');
    _('100    ...');
    sort;
    for j:=1 to 100 do
        _(inttostr(j)+'. '+data[j].word+' ['+inttostr(data[j].count)+']');


    strs.Free;

end;

procedure TForm1.stfMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var n:tsearchrec;
    i:integer;
begin
    i:=0;
    findfirst(stf.Path+'\*.msg',faAnyFile,n);
    while findnext(n)=0 do i:=i+1;
    _('  '+stf.Path+'  '+inttostr(i)+' ');

end;

procedure TForm1.Button1Click(Sender: TObject);
var n:tsearchrec;
    i:integer;

begin
    while not fileexists(str+'thebat.exe') do begin
        if od.Execute then begin
            str:=extractfilepath(od.FileName);
            break;
        end
        else exit;
    end;
    winexec(pchar(str+'thebat.exe /EXPORTU='+edit3.text+';F='+edit4.text+';D='+stf.path),SW_SHOW);
    i:=0;
    findfirst(stf.Path+'\*.msg',faAnyFile,n);
    while findnext(n)=0 do i:=i+1;
    _('  '+stf.Path+'  '+inttostr(i)+' ');

end;

end.
